function lge() {
    //Global Variables
    var _this = this;
    var slideShowSpeed;
    var currentIndex;
    var fullScreenMode;
    var bSlideShowIsRunning;
    var randomSlideShow;
    var imageList = [];
    var actualSize = {};
    var containerDiv;
    var containerWidth;
    var containerHeight;
    var leftTopPos;
    var interval = null;
    var zoomStep = 1;
    var speed = 4000;
    var rotated = 0;
    var rotatedStyle = "";
    var flipppedStyle = "";
    var key_naviObj = null;
    var objectFocussed = null;
    var bRemove = false;
    var returnFocus = false;
    var slideMode = false;
    var zoomMode = false;
    var arrowIndex = 1;
    var rowNo = 1;
    var showZoomControl = false;
    var bControlsAdded = false;

    var randomArr;
    var Xpos = 1;
    var Ypos = 1;
    var focusCallBack = null;

    //Constructor
    this._construct = function() {
        randomArr = [];
        slideShowSpeed = "medium";
        currentIndex = 0;
        fullScreenMode = false;
        randomSlideShow = false;
        bSlideShowIsRunning = false;
    }

    //Public Functions
    /*
	Function createImgViewer()
	@param -container - div container, framewok controls -Boolean, callBack-CallBack function for connecting key navigation with application
	@Description - This function create imageViewer for the given container div and it will add contols to frmework based on value of controls parameter
	Returns  -void
	 */
    this.createImgViewer = function(container, controls, callBack) {
        imageList = $(container).find("li img");
        containerDiv = container;
        if (callBack !== null) {
            focusCallBack = callBack;
        }
        leftTopPos = [$(containerDiv).position().left, $(containerDiv).position().top]
            $(containerDiv).css("background-color", "black");
        $(containerDiv).css("overflow", "hidden");
        containerWidth = $(container).width();
        containerHeight = $(container).height();
        bControlsAdded = controls;
        if (bControlsAdded) {
            addControls(container);
            key_naviObj = keyNavigation();
        }
        reSizeNcenter();

    };
    /*
	Function addImage()
	@param -url - path url of the new image to be added
	@Description - This function adds image at the end of the existing image list.
	Returns  -void
	 */
    this.addImage = function(url) {
        if (zoomMode) {
            toast("Exit zoom mode to perform this operation");
            return;
        }
        $(containerDiv).find("ul:first").append('<li><img src="' + url + '"></li>');
        imageList = $(containerDiv).find("ul:first").find("li img");
        $(imageList[imageList.length - 1]).parent().css({
            "position": "relative",
            top: '0px',
            left: '0px'
        });
        $(imageList[imageList.length - 1]).attr("onload", "onImageLoadHandler(this)");
        $(imageList[imageList.length - 1]).css("display", "none");
        toast("Image is added in last");
        if (!bSlideShowIsRunning)
            showHideArrowsNoFocus();
        return;
    };

    /*
	Function removeImage()
	@param -
	@Description - This function removes current showing image from the existing image list and shows next image.
					It shows previous image if last image is removed.
	Returns  -void
	 */
    this.removeImage = function() {
        if (zoomMode) {
            toast("Exit zoom mode to perform this operation");
            return;
        }
        if (interval != null) {
            toast("Stop the SlideShow to remove image");
            return;
        }
        if (imageList.length == 1) {
            toast("Can't delete last image in list");
            return;
        }
        if (currentIndex > -1 && imageList.length > 1) {
            var idx = currentIndex + 1;
            var isLast = false;
            if (currentIndex == imageList.length - 1) {
                isLast = true;
            }
            $(containerDiv).find("ul:first").find("li:nth-child(" + idx + ")").remove();
            imageList = $(containerDiv).find("ul:first").find("li img");
            bRemove = true;
            if (isLast) {
                _this.gotoImage(currentIndex);
            } else {
                _this.gotoImage(currentIndex + 1);

            }
        }
        showHideArrowsNoFocus();
        return;
    };

    /*
	Function zoom()
	@param - Show, In, Out, left, right, Up, Down, Back
	@Description - This function will show all zooms related controls. 
					it will perform respective operation based on value of str.
	Returns  -void
	 */
    this.zoom = function(str) {
        var imgElement = (imageList[currentIndex]);
        var scale = 150 / 100;
        var zoomP = 150 * zoomStep;

        var wraperW = fullScreenMode ? 1280: containerWidth;;
        var wraperH = fullScreenMode ? 720: containerHeight;;

        var currentWidth;
        var currentHeight;

        if (Math.abs(rotated) == 0 || Math.abs(rotated) == 360 || Math.abs(rotated) == 180) {
            currentWidth = $(imgElement).width();
            currentHeight = $(imgElement).height();
        } else {
            currentWidth = $(imgElement).height();;
            currentHeight = $(imgElement).width();
        }

        if (str == "show" && bControlsAdded) {
            showControl("zoom");
            $("#prev").hide();
            $("#next").hide();
            showZoomControl = true;
        } else if (str == "in") {
            if (zoomStep < 5) {
                $(imgElement).css({
                    "width": currentWidth * scale,
                    "height": currentHeight * scale
                });
                setCenter(imageList[currentIndex]);
                toast("Zoomed " + zoomP + "%");
                zoomStep++;
            } else {
                toast("Image can't be zoom beyond this");
            }
            return;
        } else if (str == "out") {
            if (currentWidth > actualSize[imgElement.src].w && currentHeight > actualSize[imgElement.src].h) {
                $(imgElement).css({
                    "width": currentWidth / scale,
                    "height": currentHeight / scale
                });
                setCenter(imageList[currentIndex]);
                zoomStep--;
            }
        } else if (str == "left") {
            var imgL = $(imgElement).parent().offset().left;
            if ($(imgElement).offset().left + 20 < $(containerDiv).offset().left) {

                $(imgElement).parent().offset({
                    "left": imgL + 20
                });

            }
        } else if (str == "up") {
            var imgT = $(imgElement).parent().offset().top;
            if ($(imgElement).offset().top + 20 < $(containerDiv).offset().top) {

                $(imgElement).parent().offset({
                    "top": imgT + 20
                });

            }
        } else if (str == "down") {
            var imgT = $(imgElement).parent().offset().top;
            var diff = ($(imgElement).height() + imgT) - (wraperH + $(containerDiv).offset().top);
            if (diff - 20 > 0) {

                $(imgElement).parent().offset({
                    "top": imgT - 20
                });

            }
        } else if (str == "right") {
            var imgL = $(imgElement).parent().offset().left;
            var diff = ($(imgElement).width() + imgL) - (wraperW + $(containerDiv).offset().left);
            //console.log(diff+"~"+imgL);
            //if(($(imgElement).offset().left -diff)< $(containerDiv).offset().left){
            if (diff - 20 > 0) {

                $(imgElement).parent().offset({
                    "left": imgL - 20
                });

            }
        } else if (str == "back") {
            showControl("normal");

        }

        return;
    }

    /*
	Function rotate()
	@param - str - 'left' / 'right'
	@Description - This function rotates the current image left or right by 90 degrees.
	Returns  -void
	 */
    this.rotate = function(str) {
        if (str == 'left') {
            rotated -= 90;
        } else if (str == 'right') {
            rotated += 90;
        }
        if (rotated >= 360) {
            rotated -= 360
        }
        if (rotated <= -360) {
            rotated += 360
        }
        rotatedStyle = "rotate(" + rotated + "deg)";
        $(imageList[currentIndex]).css({
            '-webkit-transform': rotatedStyle + " " + flipppedStyle
        });
        $(imageList[currentIndex]).css("width", "");
        $(imageList[currentIndex]).css("height", "");
        resize_Image(imageList[currentIndex]);
        zoomStep = 1;
        return;
    }

    /*
	Function setFrameworkFocus()
	@param - str - 'up' / 'down'/ 'left'/ 'right'
	@Description - This function set key navigation and focus the appropriate control of framework control based on position of framework controls with respect to application control.
	Returns  -void
	 */
    this.setFrameworkFocus = function(str) {
        if (str == "down") {
            if (!slideMode && !zoomMode) {
                if (currentIndex == 0) {
                    if (imageList.length > 1) {
                        objectFocussed = $("#next")[0];
                        $(objectFocussed).toggleClass("arrowRighthover");
                        $("#next").css({
                            "position": "absolute",
                            left: $(containerDiv).width() - 120
                        });
                        $(objectFocussed).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex + 2) + "/" + imageList.length + '</div>');
                        $(objectFocussed).append('<div id="arrowTitle" class="arrowTitle">Next</div>');
                        arrowIndex = 1;
                        rowNo = 0;
                    } else {
                        objectFocussed = $("#lgImg_control li:first");
                        $(objectFocussed).removeClass("btn_default").addClass("btn_focus");
                        rowNo = 1;
                        btnIndex = 0;
                    }
                } else if (currentIndex == imageList.length - 1) {
                    objectFocussed = $("#prev")[0];
                    $(objectFocussed).toggleClass("arrowLefthover");
                    $(objectFocussed).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex) + "/" + imageList.length + '</div>');
                    $(objectFocussed).append('<div id="arrowTitle" class="arrowTitle">Previous</div>');
                    arrowIndex = 0;
                    rowNo = 0;
                } else if (currentIndex > 0 && currentIndex < imageList.length - 1) {
                    if ($(objectFocussed).attr("id") == "next") {
                        objectFocussed = $("#next")[0];
                        $(objectFocussed).toggleClass("arrowRighthover");
                        $("#next").css({
                            "position": "absolute",
                            left: $(containerDiv).width() - 120
                        });
                        $(objectFocussed).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex + 2) + "/" + imageList.length + '</div>');
                        $(objectFocussed).append('<div id="arrowTitle" class="arrowTitle">Next</div>');
                        arrowIndex = 1;
                        rowNo = 0;
                    } else if ($(objectFocussed).attr("id") == "prev") {
                        objectFocussed = $("#prev")[0];
                        $(objectFocussed).toggleClass("arrowLefthover");
                        $(objectFocussed).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex) + "/" + imageList.length + '</div>');
                        $(objectFocussed).append('<div id="arrowTitle" class="arrowTitle">Previous</div>');
                        arrowIndex = 0;
                        rowNo = 0;
                    }

                } else {
                    $(objectFocussed).removeClass("btn_default").addClass("btn_focus");
                }
            } else if (slideMode || zoomMode) {
                $(objectFocussed).removeClass("btn_default").addClass("btn_focus");
            }
        } else if (str == "up") {
            $(objectFocussed).removeClass("btn_default").addClass("btn_focus");
        } else if (str == "left") {
            if (currentIndex == 0) {
                $(objectFocussed).toggleClass("arrowRighthover");
                $("#next").css({
                    "position": "absolute",
                    left: $(containerDiv).width() - 120
                });
                $(objectFocussed).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex + 2) + "/" + imageList.length + '</div>');
                $(objectFocussed).append('<div id="arrowTitle" class="arrowTitle">Next</div>');
            } else {
                $(objectFocussed).toggleClass("arrowLefthover");
                $(objectFocussed).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex) + "/" + imageList.length + '</div>');
                $(objectFocussed).append('<div id="arrowTitle" class="arrowTitle">Previous</div>');
            }
        } else if (str == "right") {
            if (currentIndex == imageList.length - 1) {
                $(objectFocussed).toggleClass("arrowLefthover");
                $(objectFocussed).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex) + "/" + imageList.length + '</div>');
                $(objectFocussed).append('<div id="arrowTitle" class="arrowTitle">Previous</div>');
            } else {
                $(objectFocussed).toggleClass("arrowRighthover");
                $("#next").css({
                    "position": "absolute",
                    left: $(containerDiv).width() - 120
                });
                $(objectFocussed).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex + 2) + "/" + imageList.length + '</div>');
                $(objectFocussed).append('<div id="arrowTitle" class="arrowTitle">Next</div>');
            }
        }
    }

    /*
	Function removeFrameworkFocus()
	@param - 
	@Description - This function will remove focus of framework control.
	Returns  -void
	 */
    this.removeFrameworkFocus = function() {
        removeFocus(objectFocussed);
    }

    /*
	Function flip()
	@param - str - 'Horizontal' / 'Vertical'
	@Description - This function mirror the current image horizontally or vertically.
	Returns  -void
	 */
    this.flip = function(str) {
        var rotatingVal = (rotated / 90) % 2;
        if (str == 'Horizontal') {
            if (rotatingVal == 0) {
                Xpos = -1 * Xpos;
            } else {
                // interchange X Y if rotated = 90,270,320...	
                Ypos = -1 * Ypos;
            }
            flipppedStyle = "scale(" + Xpos + "," + Ypos + ")";
            $(imageList[currentIndex]).css({
                '-webkit-transform': rotatedStyle + " " + flipppedStyle
            });
        } else if (str == 'Vertical') {
            if (rotatingVal == 0) {
                Ypos = -1 * Ypos;
            } else {
                // interchange X Y if roatated = 90,270,320...					
                Xpos = -1 * Xpos;
            }
            flipppedStyle = "scale(" + Xpos + "," + Ypos + ")";
            $(imageList[currentIndex]).css({
                '-webkit-transform': rotatedStyle + " " + flipppedStyle
            });
        }
        return;
    }

    /*
	Function startSlideShow()
	@param - 
	@Description - This function starts slide show. calls next() to show next image with set slide speed.
	Returns  -void
	 */
    this.startSlideShow = function() {
        if (speed == "2000") {
            $("#Medium").css({
                "color": "#888888"
            });
            $("#Fast").css({
                "color": "#39F"
            });
            $("#Slow").css({
                "color": "#888888"
            });
        }
        if (speed == "4000") {
            $("#Medium").css({
                "color": "#39F"
            });
            $("#Fast").css({
                "color": "#888888"
            });
            $("#Slow").css({
                "color": "#888888"
            });
        }
        if (speed == "6000") {
            $("#Medium").css({
                "color": "#888888"
            });
            $("#Fast").css({
                "color": "#888888"
            });
            $("#Slow").css({
                "color": "#39F"
            });
        }
        if (currentIndex == imageList.length - 1) {
            _this.first();
        }
        if (interval != null) {
            // toggles the visibility of random and order buttons while slideshow
            $("#unshuffle").toggle();
            $("#shuffle").toggle();
            clearInterval(interval);
            interval = null;
        }
        interval = setInterval(function() {
            _this.next();
        }, speed);
        if (bControlsAdded) {
            $("#prev").hide();
            $("#next").hide();
        }
        bSlideShowIsRunning = true;
        return;
    }

    /*
	Function stopSlideShow()
	@param - 
	@Description - This function stops slide show. Resets interval and required variables.
	Returns  -void
	 */
    this.stopSlideShow = function() {
        if (interval != null) {
            clearInterval(interval);
            interval = null;
        }

        randomSlideShow = false;
        if (randomArr.length > 0) {
            currentIndex = $.inArray(randomArr[currentIndex], imageList);
            randomArr.length = 0;
        }
        if (!bSlideShowIsRunning && bControlsAdded) {
            if ((currentIndex == imageList.length - 1)) {
                $("#next").hide();
                $("#prev").show();
            } else if ((currentIndex == 0)) {
                $("#prev").hide();
                $("#next").show();
            } else if ((currentIndex < imageList.length - 1) && (currentIndex > 0)) {
                $("#prev").show();
                $("#next").show();
            }
        }

        if (bControlsAdded) {
            //when slideshow not running
            //show shuffle option
            $("#shuffle").show();
            $("#unshuffle").hide();
        }
        return;
    }

    /*
	Function getSlideShowSpeed()
	@param - 
	@Description - This function returns slide show speed as - slow / medium / fast.
	Returns  -void
	 */
    this.getSlideShowSpeed = function() {
        return slideShowSpeed;
    }

    /*
	Function setSlideShowSpeed()
	@param - str - 'slow' / 'medium' / 'fast'
	@Description - This function sets slide show speed to - slow / medium / fast.
					Also updates the speed for currently running slideshow.
	Returns  -void
	 */
    this.setSlideShowSpeed = function(str) {
        slideShowSpeed = str;
        switch (str) {
        case 'slow':
            speed = 6000;
            break;
        case 'medium':
            speed = 4000;
            break;
        case 'fast':
            speed = 2000;
            break;
        default:
            speed = 4000;
            break;
        }
        if (interval != null) {
            clearInterval(interval);
            interval = setInterval(function() {
                _this.next();
            }, speed);
        }
        if (bControlsAdded) {
            if (speed == "2000") {
                $("#Medium").css({
                    "color": "#888888"
                });
                $("#Fast").css({
                    "color": "#39F"
                });
                $("#Slow").css({
                    "color": "#888888"
                });
            }
            if (speed == "4000") {
                $("#Medium").css({
                    "color": "#39F"
                });
                $("#Fast").css({
                    "color": "#888888"
                });
                $("#Slow").css({
                    "color": "#888888"
                });
            }
            if (speed == "6000") {
                $("#Medium").css({
                    "color": "#888888"
                });
                $("#Fast").css({
                    "color": "#888888"
                });
                $("#Slow").css({
                    "color": "#39F"
                });
            }
        }
        return;
    }

    /*
	Function setDisplayMode()
	@param - 
	@Description - This function sets display mode - normal or fullscreen.
	Returns  -void
	 */
    this.setDisplayMode = function() {
        if (bControlsAdded) {
            setDisplayModeWithControls();
        } else {
            setDisplayModeWithNoControls();
        }
        return;
    }

    function setDisplayModeWithControls() {
        if (!fullScreenMode) {
            $(containerDiv).css({
                "position": "absolute",
                left: 0,
                top: 0,
                width: 1280,
                height: 720,
                "z-index": 100
            });
            setControlButton();

            $(".main_btn").hide();

            $("#lgImg_control").removeClass("bottom_btn").addClass("full_bottom ctrls_outline");
            $("#lgImg_control ul").addClass("ctrls_outline");
            $("#lgImg_slideControl ul").addClass("ctrls_outline");
            $("#lgImg_control").css({
                "position": "absolute",
                top: $(containerDiv).height() - $("#lgImg_control").height() * 2.2,
                width: $(containerDiv).width() * .944,
                "margin": "20px 30px",
                "padding": "6px 7px 7px 6px",
                "background": "-webkit-gradient(linear,left top,right top,color-stop(0%,rgba(191,191,191,0.45)),color-stop(38%,rgba(224,224,224,0.45)),color-stop(60%,rgba(171,171,171,0.45)),color-stop(100%,rgba(255,255,255,0.45)))",
                "border-radius": "5px",
                "box-shadow": "inset 1px 1px 2px rgba(0,0,0,0.15),inset -1px -2px 2px rgba(255,255,255,0.15)",
                "text-align": "center",
                "display": "block"
            });

            fullScreenMode = true;
        } else {
            //$("body").css("background-color","");
            $("#lgImg_control").removeClass("full_bottom ctrls_outline").addClass("bottom_btn");
            $("#lgImg_control ul").removeClass("ctrls_outline");
            $("#lgImg_slideControl ul").removeClass("ctrls_outline");

            $(containerDiv).css({
                "background-color": "black",
                "position": "absolute",
                left: leftTopPos[0],
                top: leftTopPos[1],
                "z-index": "auto",
                width: containerWidth,
                height: containerHeight
            });
            setControlButton();
            $(".main_btn").show();
            $("#lgImg_control").css({
                "position": "absolute",
                top: $(containerDiv).height() - $("#lgImg_control").height(),
                width: $(containerDiv).width(),
                height: $("#lgImg_control").height(),
                "border": "none",
                "background": "none",
                "margin": "0px",
                "padding": "0px",
                "text-align": "center",
                "display": "block"
            });
            fullScreenMode = false;

        }
        for (var i = 0; i < imageList.length; i++) {
            resetImgStyle(imageList[i]);
        }
        zoomStep = 1;
        return;

    }

    function setDisplayModeWithNoControls() {
        if (!fullScreenMode) {
            $(containerDiv).css({
                "position": "absolute",
                left: 0,
                top: 0,
                width: 1280,
                height: 720,
                "z-index": 100
            });
        } else {
            $(containerDiv).css({
                "background-color": "black",
                "position": "absolute",
                left: leftTopPos[0],
                top: leftTopPos[1],
                "z-index": "auto",
                width: containerWidth,
                height: containerHeight
            });
        }
    }

    /*
	Function getDisplayMode()
	@param - 
	@Description - This function returns display mode - Normal or FullScreen.
	Returns  -void
	 */
    this.getDisplayMode = function() {
        var mode = "Normal";

        if (fullScreenMode) {
            mode = "FullScreen";
        }

        return mode;
    }

    /*
	Function setRandomSlideShow()
	@param - 
	@Description - This function stops current slideshow, shuffles imagelist and then again start slideshow.
	Returns  -void
	 */
    this.setRandomSlideShow = function() {
        bSlideShowIsRunning = true;
        _this.stopSlideShow();
        randomSlideShow = true;
        getShuffleArray();
        var idx = $.inArray(randomArr[0], imageList);
        // show first image of shuffled array		
        _this.gotoImage(idx + 1);
        currentIndex = 0;

        if (bControlsAdded) {
            // toggles the visibility of random and order buttons while slideshow
            $("#unshuffle").toggle();
            $("#shuffle").toggle();
        }

        setTimeout(function() {
            _this.startSlideShow();
        }, 500);
        return;

    }

    /*
	Function getRandomSlideShow()
	@param - 
	@Description - This function returns boolean based on slide show is running randomly or not. 
	Returns  -void
	 */
    this.getRandomSlideShow = function() {
        return randomSlideShow;
    }

    /*
	Function next()
	@param - 
	@Description - This function shows next image for current image. If random slide show, it 
	  				will show next image from random list.
	Returns  -void
	 */
    this.next = function() {
        resetImgStyle(imageList[currentIndex]);
        zoomStep = 1;
        if (currentIndex < imageList.length - 1) {
            hideAllImg();
            currentIndex++;
            if (bControlsAdded) {
                $("#next #arrowNumber").text((currentIndex + 2) + "/" + imageList.length);
            }

            if (randomSlideShow) {
                $(randomArr[currentIndex]).css("display", "block");
            } else {
                $(imageList[currentIndex]).css("display", "block");
            }
        } else {

            if (interval != null) {
                if (bControlsAdded)
                    showControl("normal");
                clearInterval(interval);
                interval = null;
            }

            if (randomArr.length > 0) {
                randomSlideShow = false;
                bSlideShowIsRunning = false;
                currentIndex = $.inArray(randomArr[currentIndex], imageList);
                randomArr.length = 0;
            }
            if (bControlsAdded) {
                //when slideshow not running
                //show shuffle option
                $("#shuffle").show();
                $("#unshuffle").hide();
            }
        }
        if (!bSlideShowIsRunning)
            showHideArrows();

        return;
    }

    /*
	Function previous()
	@param - 
	@Description - This function shows previous image for current image.
	Returns  -void
	 */
    this.previous = function() {
        resetImgStyle(imageList[currentIndex]);
        zoomStep = 1;
        if (currentIndex > 0) {
            currentIndex--;

            hideAllImg();
            $(imageList[currentIndex]).css("display", "block");
            if (bControlsAdded) {
                $("#prev #arrowNumber").text((currentIndex) + "/" + imageList.length);
            }
        }
        showHideArrows();
        return;
    }

    /*
	Function first()
	@param - 
	@Description - This function shows first image of the image list.
	Returns  -void
	 */
    this.first = function() {
        if ((currentIndex == 0) && (interval == null)) {
            toast("You are on first image");
            return;
        }
        resetImgStyle(imageList[currentIndex]);
        zoomStep = 1;
        currentIndex = 0;
        hideAllImg();
        $(imageList[currentIndex]).css("display", "block");
        if (bControlsAdded) {
            $("#prev").hide();
            $("#next").show();
        }
        return;
    }

    /*
	Function last()
	@param - 
	@Description - This function shows last image of the image list.
	Returns  -void
	 */
    this.last = function() {
        if ((currentIndex == imageList.length - 1) && (interval == null)) {
            toast("You are on last image");
            return;
        }
        resetImgStyle(imageList[currentIndex]);
        zoomStep = 1;
        currentIndex = imageList.length - 1;
        hideAllImg();
        $(imageList[currentIndex]).css("display", "block");
        if (bControlsAdded) {
            $("#next").hide();
            $("#prev").show();
        }
        return;
    }

    /*
	Function last()
	@param - num - image number. Starts with 1 (1,2,3,...n)
	@Description - This function shows image with given number of the image list.
	Returns  -void
	 */
    this.gotoImage = function(num) {
        if (zoomMode) {
            toast("Exit zoom mode to perform this operation");
            return;
        }

        if (!bRemove && !randomSlideShow && currentIndex == (num - 1)) {
            toast("You are viewing image " + num);
            return;
        }

        if (!bRemove && (num) > imageList.length) {
            toast("Image " + num + " Doesn't Exist");
            return;
        }

        if (!bRemove)
            resetImgStyle(imageList[currentIndex]);

        if (num <= imageList.length) {
            currentIndex = num - 1;
            hideAllImg();
            $(imageList[currentIndex]).css("display", "block");
            bRemove = false;
        }
        if (!bSlideShowIsRunning)
            showHideArrowsNoFocus();
        zoomStep = 1;
        return;
    }

    this.focusNext = function() {
        returnFocus = moveFocus(1, "");
        return returnFocus;
    }

    this.focusPrevious = function() {
        returnFocus = moveFocus( - 1, "");
        return returnFocus;
    }

    this.focusUp = function() {
        returnFocus = moveFocus( - 1, "up");
        return returnFocus;
    }

    this.focusDown = function() {
        returnFocus = moveFocus(1, "down");
        return returnFocus;
    }

    this.doSelection = function() {
        buttonClicked();
    }

    /*
	Function mouseWheel()
	@param - 
	@Description - This function will change index of currently shown image based on direction of mouse rolled.
	Returns  -void
	 */
    this.mouseWheel = function() {
        var rolled = 0;
        if (event.wheelDelta > 0)
            app.next();
        else
            app.previous();
    }
    //Private Functions
    /*
	Function hideAllImg()
	@param - 
	@Description - This function hide currently shown image.
	Returns  -void
	 */
    hideAllImg = function() {
        $(imageList).filter(function() {
            return $(this).css("display") == "block"
        }).css("display", "none");
    }

    /*
	Function setControlButton()
	@param - 
	@Description - This function positions control buttons.
	Returns  -void
	 */
    setControlButton = function() {
        var controlBtntop = $(containerDiv).height() / 2 - 90 / 2;
        var controlBtnleft = $(containerDiv).width();
        var tmpTop = $(lgImg_control).height();
        $("#prev").css({
            "position": "absolute",
            top: controlBtntop
        });
        $("#next").css({
            "position": "absolute",
            top: controlBtntop,
            left: controlBtnleft - 50
        });

        $("#lgImg_control").css({
            "position": "absolute",
            top: $(containerDiv).height() - tmpTop,
            width: $(containerDiv).width(),
            height: tmpTop,
            "border": "none",
            "margin": "0px",
            "padding": "0px",
            "text-align": "center",
            "display": "block"
        });

        $("#lgImg_slideControl").css({
            "position": "absolute",
            top: $(containerDiv).height() - tmpTop,
            width: $(containerDiv).width(),
            height: tmpTop,
            "border": "none",
            "margin": "auto",
            "text-align": "center",
            "display": "none"
        });
        $("#lgImg_zoomControl").css({
            "position": "absolute",
            top: $(containerDiv).height() - tmpTop,
            width: $(containerDiv).width(),
            height: tmpTop,
            "border": "none",
            "margin": "auto",
            "text-align": "center",
            "display": "none"
        });
    }

    /*
	Function getShuffleArray()
	@param - 
	@Description - copies existing image list into another array and shuffle images
				for random slide show.					
	Returns  -void
	 */
    getShuffleArray = function() {
        randomArr = imageList.slice(0);

        for (var i = randomArr.length - 1; i > -1; i--) {
            var j = Math.floor(Math.random() * (i + 1));
            var temp = randomArr[i];
            randomArr[i] = randomArr[j];
            randomArr[j] = temp;
        }
        return;
    }

    /*
     * Function addControls()
     * @param -container- image container 
     * @Description - it will add all the control buttons and their handlers method.
     * Returns  -void
     */

    addControls = function(container) {
        $(container).append('<div id="prev" class="arrowLeftNormal"></div>');
        $(container).append('<div id="next" class="arrowRightNormal"></div>');

        $(container).append('<!-- Viewer_bottom_BTN -->' + '<div id="lgImg_control" class="bottom_btn btn01"> ' + '<ul >' + '<li  id="first" class="btn_focus">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/first_img_default.png" class="icon" alt="First" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + ' </p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/first_img_focus.png" class="icon" alt="First" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + ' </li>' + 
'<li id="last" class="btn_default">' + ' <p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/last_img_default.png" class="icon" alt="Last" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + ' <p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/last_img_focus.png" class="icon" alt="Last" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + ' </li>' + '<li id="FlipHorizontal" class="btn_default">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/flip_hori_default.png" class="icon" alt="Flip Horizontal" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/flip_hori_focus.png" class="icon" alt="Flip Horizontal" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + ' </p>' + '</li>' + '<li id="FlipVertical" class="btn_default">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/flip_vart_default.png" class="icon" alt="Flip Vertical" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + ' </p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/flip_vart_focus.png" class="icon" alt="Flip Vertical"  />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '</li>' + '<li id="rotateLeft" class="btn_default">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/rotate_left_default.png" class="icon" alt="Rotate Left" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/rotate_left_focus.png" class="icon" alt="Rotate Left" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '<li id="rotateRight" class="btn_default">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/rotate_right_default.png" class="icon" alt="Rotate Right" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/rotate_right_focus.png" class="icon" alt="Rotate Right" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + ' </p>' + '</li>' + '<li id="startSlideShow" class="btn_default">' + ' <p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/slideshow_default.png" class="icon" alt="Slide Show" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/slideshow_focus.png" class="icon" alt="Slide Show" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '<li id="Zoom" class="btn_default">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoom_default.png" class="icon" alt="Zoom" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoom_focus.png" class="icon" alt="Zoom" />' + ' <img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '<li id="FullScreen" class="btn_default btn_last">' + ' <p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/fullsize_default.png" class="icon" alt="Full-Size" />' + ' <img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + ' <img src="../lge/framework/ImageViewer/ui/images/imageviewer/fullsize_focus.png" class="icon" alt="Full-Size" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '</ul>' + '</div>' + '<!-- //Viewer_bottom_BTN -->');

        $(container).append('<div id="lgImg_slideControl" class="btn01">' + '<ul >' + '<li id="Random" class="btn_default">' + '<div id="shuffle">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/shuffle_default.png" class="icon" alt="Shuffle" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/shuffle_focus.png" class="icon" alt="Shuffle" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</div>' + '<div id="unshuffle">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/unshuffle_default.png" class="icon" alt="Shuffle" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/unshuffle_focus.png" class="icon" alt="Shuffle" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</div>' + '</li>' + 
'<li id="Slow" class="btn_default">' + '<p class="default">' + '6 Sec' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line"/>' + '</p>' + '<p class="focus">' + '6 Sec' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '<li id="Medium" class="btn_default">' + '<p class="default">' + '4 Sec' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '4 Sec' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '<li id="Fast" class="btn_default">' + '<p class="default">' + '2 Sec' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '2 Sec' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '</li>' + '<li id="stopSlideShow" class="btn_default btn_last">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/stop_default.png" class="icon" alt="Stop" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/stop_focus.png" class="icon" alt="Stop" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '</ul>' + '</div>');

        $(container).append('<!-- Viewer_bottom_BTN -->' + '<div id="lgImg_zoomControl" class="btn01"> ' + '<ul >' + '<li  id="zoomIn" class="btn_focus">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomIn_default.png" class="icon" alt="First" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + ' </p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomIn_focus.png" class="icon" alt="First" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + ' </li>' + 
'<li id="zoomOut" class="btn_default">' + ' <p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomOut_default.png" class="icon" alt="Last" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + ' <p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomOut_focus.png" class="icon" alt="Last" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + ' </li>' + '<li id="zoomLeft" class="btn_default">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomLeft_default.png" class="icon" alt="Flip Horizontal" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomLeft_focus.png" class="icon" alt="Flip Horizontal" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + ' </p>' + '</li>' + '<li id="zoomUp" class="btn_default">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomUp_default.png" class="icon" alt="Flip Vertical" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + ' </p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomUp_focus.png" class="icon" alt="Flip Vertical"  />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '</li>' + '<li id="zoomDown" class="btn_default">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomDown_default.png" class="icon" alt="Rotate Left" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomDown_focus.png" class="icon" alt="Rotate Left" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '<li id="zoomRight" class="btn_default ">' + '<p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomRight_default.png" class="icon" alt="Rotate Right" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomRight_focus.png" class="icon" alt="Rotate Right" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + ' </p>' + '</li>' + '<li id="zoomBack" class="btn_default btn_last">' + ' <p class="default">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomBack_default.png" class="icon" alt="Slide Show" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_default.png" class="line" />' + '</p>' + '<p class="focus">' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/zoomBack_focus.png" class="icon" alt="Slide Show" />' + '<img src="../lge/framework/ImageViewer/ui/images/imageviewer/btn_line_focus.png" class="line" />' + '</p>' + '</li>' + '</ul>' + '</div>');

        $("#lgImg_control ul").children().each(function(i) {
            switch ($(this).attr("id")) {
            case "startSlideShow":
                addEventHandler(this, "click", function() {
                    showControl("slideShow");
                    _this.startSlideShow();
                });
                break;
            case "FlipHorizontal":
                addEventHandler(this, "click", function() {
                    _this.flip('Horizontal');
                });
                break;
            case "FlipVertical":
                addEventHandler(this, "click", function() {
                    _this.flip('Vertical');
                });
                break;
            case "rotateLeft":
                addEventHandler(this, "click", function() {
                    _this.rotate("left");
                });
                break;
            case "rotateRight":
                addEventHandler(this, "click", function() {
                    _this.rotate("right");
                });
                break;
            case "Zoom":
                addEventHandler(this, "click", function() {
                    _this.zoom("show")
                    });
                break;
            case "FullScreen":
                addEventHandler(this, "click", function() {
                    _this.setDisplayMode();
                });
                break;
            case "first":
                addEventHandler(this, "click", function() {
                    _this.first();
                });
                break;
            case "last":
                addEventHandler(this, "click", function() {
                    _this.last();
                });
                break;
            }
        });
        $("#lgImg_slideControl ul").children().each(function(i) {
            switch ($(this).attr("id")) {
            case "Random":
                addEventHandler(this, "click", function() {
                    if (!randomSlideShow) {
                        _this.setRandomSlideShow();
                    } else {
                        _this.stopSlideShow();
                        _this.first();
                        _this.startSlideShow();
                        randomSlideShow = false;
                    }
                });
                break;
            case "stopSlideShow":
                addEventHandler(this, "click", function() {
                    showControl("normal");
                    bSlideShowIsRunning = false;
                    _this.stopSlideShow()
                    });
                break;
            case "Slow":
                addEventHandler(this, "click", function() {
                    _this.setSlideShowSpeed("slow");
                });
                break;
            case "Medium":
                addEventHandler(this, "click", function() {
                    _this.setSlideShowSpeed("medium");
                });
                break;
            case "Fast":
                addEventHandler(this, "click", function() {
                    _this.setSlideShowSpeed("fast");
                });
                break;
            }
        });
        $("#lgImg_zoomControl ul").children().each(function(i) {
            switch ($(this).attr("id")) {
            case "zoomIn":
                addEventHandler(this, "click", function() {
                    _this.zoom("in")
                    });
                break;
            case "zoomOut":
                addEventHandler(this, "click", function() {
                    _this.zoom("out");
                });
                break;
            case "zoomLeft":
                addEventHandler(this, "click", function() {
                    _this.zoom("left");
                });
                break;
            case "zoomUp":
                addEventHandler(this, "click", function() {
                    _this.zoom("up");
                });
                break;
            case "zoomDown":
                addEventHandler(this, "click", function() {
                    _this.zoom("down");
                });
                break;
            case "zoomRight":
                addEventHandler(this, "click", function() {
                    _this.zoom("right");
                });
                break;
            case "zoomBack":
                addEventHandler(this, "click", function() {
                    _this.zoom("back");
                });
                break;

            }
        });
        document.getElementById("prev").addEventListener("click", _this.previous, false);
        document.getElementById("next").addEventListener("click", _this.next, false);

        showHideArrows();
        $("#prev").hide();
        $("#unshuffle").toggle();
        setControlButton();

    }

    /*
     * Function addEventHandler()
     * @param -elem- control button element 
     * @param -eventType-type of event
     * @param -handler- event handler method
     * @Description - it will call event handler method.
     * Returns  -void
     */

    addEventHandler = function(elem, eventType, handler) {
        if (elem.addEventListener)
            elem.addEventListener(eventType, handler, false);
        else if (elem.attachEvent)
            elem.attachEvent('on' + eventType, handler);
    }

    /*
     * Function reSizeNcenter()
     * @param -void
     * @Description - it will set the display of image according to position of center.
     * Returns  -void
     */

    reSizeNcenter = function() {
        for (var i = 0; i < imageList.length; i++) {
            $(imageList[i]).parent().css({
                "position": "relative",
                top: '0px',
                left: '0px'
            });
            $(imageList[i]).attr("onload", "onImageLoadHandler(this)");
            i == 0 ? $(imageList[i]).css("display", "block") : $(imageList[i]).css("display", "none");

        }
    }

    /*
     * Function onImageLoadHandler()
     * @param -element-the current image element being displayed
     * @Description - it will store width and height of all image in list on load of document.
     * Returns  -void
     */

    onImageLoadHandler = function(element) {
        actualSize[element.src] = {
            "w": element.width,
            "h": element.height
        };
        resize_Image(element);
    }

    /*
     * Function resetImgStyle()
     * @param -elm-the current image element being displayed
     * @Description - it will reset style of image being displayed.
     * Returns  -void
     */

    resetImgStyle = function(elm) {
        var disp = $(elm).css("display");
        $(elm).removeAttr('style');
        $(elm).css("display", disp);
        resize_Image(elm);
    }

    /*
     * Function getRotationDegrees()
     * @param -obj-the current image element being displayed
     * @Description - it will return current rotation degree of image being displayed.
     * Returns  -void
     */

    getRotationDegrees = function(obj) {
        var matrix = $(obj).css("-webkit-transform") || obj.css("transform");
        if (matrix !== 'none') {
            var values = matrix.split('(')[1].split(')')[0].split(',');
            var a = values[0];
            var b = values[1];
            var angle = Math.round(Math.atan2(b, a) * (180 / Math.PI));
        } else {
            var angle = 0;
        }
        return angle;
    }

    /*
     * Function resize_Image()
     * @param -imgElmnt-the current image element being displayed
     * @Description - it will resize the image based on rotation degree.
     * Returns  -void
     */

    resize_Image = function(imgElmnt) {

        var trans = getRotationDegrees(imgElmnt);
        var maxW = $(containerDiv).width();
        var maxH = $(containerDiv).height() - 48;

        var currW = $(imgElmnt).width();
        var currH = $(imgElmnt).height();

        $(imgElmnt).css({
            "width": "",
            "height": ""
        });

        var ratio = $(imgElmnt).height() / $(imgElmnt).width();

        $(imgElmnt).css({
            "width": currW,
            "height": currH
        });

        if (Math.abs(trans) == 0 || Math.abs(trans) == 180) {
            if (currW >= maxW && ratio <= 1) {
                currW = maxW;
                currH = Math.ceil(currW * ratio);
            }
            if (currH >= maxH) {
                currH = maxH;
                currW = Math.ceil(currH / ratio);
            }

        } else {
            if (currW >= maxH && ratio <= 1) {
                currW = maxH;
                currH = Math.ceil(currW * ratio);
            }
            if (currH >= maxW) {
                currH = maxW;
                currW = Math.ceil(currH / ratio);
            }
        }
        $(imgElmnt).css({
            width: currW,
            height: currH
        });
        setCenter(imgElmnt);
    }

    /*
     * Function setCenter()
     * @param -element-the current image element being displayed
     * @Description - it will set image position and size according to container size.
     * Returns  -void
     */

    setCenter = function(element) {
        var maxW = fullScreenMode ? 1280: containerWidth;
        var maxH = fullScreenMode ? 720: (containerHeight - 48);
        var currW = $(element).width();
        var currH = $(element).height();
        var left = Math.ceil((maxW - currW) / 2);
        var top = Math.ceil((maxH - currH) / 2);
        $(element).parent().css({
            left: left,
            top: top
        });
    }

    /*
     * Function toast()
     * @param -msg-the message shows to user
     * @Description - it will inform user about functionalities and error by message.
     * Returns  -void
     */

    toast = function(msg) {
        var container = containerDiv;
        var maxW = $(container).width();
        var maxH = $(container).height();

        var msgW = 0.2 * maxW;
        var msgH = 0.2 * maxH;

        $("<div>" + msg + "</div>").css({
            "display": "block",
            "width": msgW,
            "heigth": msgH,
            "opacity": 0.86,
            "border-radius": "10px",
            "top": (maxH / 2) - (msgH / 2),
            "left": (maxW / 2) - (msgW / 2),
            "overflow": "hidden",
            "position": "absolute",
            "background-color": "#111",
            "z-index": "auto",
            "text-align": "center",
            "color": "#EEE",
            "border": "#BBB 1px solid"
        }).appendTo(container).delay(1500).fadeOut(400, function() {
            $(this).remove();
        });
    };
    /*
     * Function showControl()
     * @param -str-the slideShow mode is activated or not
     * @Description - it will show and hide cotrol buttons based on the slideshow status.
     * Returns  -void
     */
    showControl = function(str) {
        if (bControlsAdded) {
            if (str == "slideShow") {

                $("#lgImg_control").css("display", "none");
                $("#lgImg_zoomControl").css("display", "none");

                $("#prev").css("display", "none");
                $("#next").css("display", "none");

                $("#lgImg_slideControl").css("display", "block");

                $("#lgImg_slideControl ul").children().each(function(i) {
                    $(this).css({
                        "width": "20%"
                    });
                });

                if (fullScreenMode) {
                    $("#lgImg_slideControl").css({
                        "position": "absolute",
                        top: $(containerDiv).height() - $("#lgImg_control").height() * 2.2,
                        width: $(containerDiv).width() * .944,
                        "margin": "20px 30px",
                        "padding": "6px 7px 7px 6px",
                        "background": "-webkit-gradient(linear,left top,right top,color-stop(0%,rgba(191,191,191,0.45)),color-stop(38%,rgba(224,224,224,0.45)),color-stop(60%,rgba(171,171,171,0.45)),color-stop(100%,rgba(255,255,255,0.45)))",
                        "border-radius": "5px",
                        "box-shadow": "inset 1px 1px 2px rgba(0,0,0,0.15),inset -1px -2px 2px rgba(255,255,255,0.15)",
                        "text-align": "center",
                        "display": "block"
                    });
                } else {
                    $("#lgImg_slideControl").css({
                        "position": "absolute",
                        top: $(containerDiv).height() - $("#lgImg_control").height(),
                        width: $(containerDiv).width(),
                        height: $("#lgImg_control").height(),
                        "border": "none",
                        "background": "none",
                        "margin": "0px",
                        "padding": "0px",
                        "text-align": "center",
                        "display": "block"
                    });
                }
                changeFocusToSlideControls();

            } else if (str == "normal") {
                $("#lgImg_control").css("display", "block");
                $("#lgImg_zoomControl").css("display", "none");

                $("#prev").css("display", "block");
                $("#next").css("display", "block");

                $("#lgImg_slideControl").css("display", "none");

                changeFocusToControls();

            } else if (str == "zoom") {
                $("#lgImg_control").css("display", "none");
                $("#lgImg_slideControl").css("display", "none");

                $("#prev").css("display", "none");
                $("#next").css("display", "none");

                $("#lgImg_zoomControl").css("display", "block");

                $("#lgImg_zoomControl ul").children().each(function(i) {
                    $(this).css({
                        "width": "14.2857%"
                    });
                });
                if (fullScreenMode) {
                    $("#lgImg_zoomControl").css({
                        "position": "absolute",
                        top: $(containerDiv).height() - $("#lgImg_zoomControl").height() * 2.2,
                        width: $(containerDiv).width() * .944,
                        "margin": "20px 30px",
                        "padding": "6px 7px 7px 6px",
                        "background": "-webkit-gradient(linear,left top,right    top,color-stop(0%,rgba(191,191,191,0.45)),color-stop(38%,rgba(224,224,224,0.45)),color-stop(60%,rgba(171,171,171,0.45)),color-stop(100%,rgba(255,255,255,0.45)))",
                        "border-radius": "5px",
                        "box-shadow": "inset 1px 1px 2px rgba(0,0,0,0.15),inset -1px -2px 2px rgba(255,255,255,0.15)",
                        "text-align": "center",
                        "display": "block"
                    });
                } else {
                    $("#lgImg_zoomControl").css({
                        "position": "absolute",
                        top: $(containerDiv).height() - $("#lgImg_control").height(),
                        width: $(containerDiv).width(),
                        height: $("#lgImg_control").height(),
                        "border": "none",
                        "background": "none",
                        "margin": "0px",
                        "padding": "0px",
                        "text-align": "center",
                        "display": "block"
                    });
                }
                changeFocusToZoomControls();

            }
            showHideArrowsNoFocus();
        }
    };

    /*
     * Function showHideArrowsNoFocus()
     * @param -
     * @Description - it will show and hide prev and next arrow buttons based on current index of the image.
     * Returns  -void
     */
    showHideArrowsNoFocus = function() {
        if (bControlsAdded) {

            if (imageList.length == 1) {
                $("#prev").hide();
                $("#next").hide();
                return;
            }
            if ((currentIndex == imageList.length - 1)) {
                $("#next").hide();
                $("#prev").show();
            } else if ((currentIndex == 0)) {
                $("#prev").hide();
                $("#next").show();
            } else if ((currentIndex < imageList.length - 1) && (currentIndex > 0)) {
                $("#prev").show();
                $("#next").show();
            }
        }

    }

    /*
     * Function showHideArrows()
     * @param -
     * @Description - it will show and hide prev and next arrow buttons based on current index of the image and focus respective image.
     * Returns  -void
     */
    showHideArrows = function() {
        if (interval == null && bControlsAdded) {
            if ((currentIndex == imageList.length - 1)) {
                $("#next").hide();
                $("#prev").show();
                $("#prev").trigger("mouseenter");
            } else if ((currentIndex == 0)) {
                $("#prev").hide();
                $("#next").show();
                $("#next").trigger("mouseenter");
            } else if ((currentIndex < imageList.length - 1) && (currentIndex > 0)) {
                $("#prev").show();
                $("#next").show();
            }
            if (imageList.length == 1) {
                $("#prev").hide();
                $("#next").hide();
            }
        }
    }

    /*
	File: keynavigation_main.js
	@Description - key navigation for main screen implementation

	 */
    keyNavigation = function() {
        var arrowRowObj = [];
        var controlsObj = [];
        var slideControlsObj = [];
        var zoomControlsObj = [];
        var btnIndex = 0;

        $("#lgImg_control ul").children().each(function(i) {
            controlsObj.push($(this));

        });
        $("#lgImg_slideControl ul").children().each(function(i) {
            slideControlsObj.push($(this));

        });
        $("#lgImg_zoomControl ul").children().each(function(i) {
            zoomControlsObj.push($(this));

        });
        arrowRowObj.push($('#prev')[0]);
        arrowRowObj.push($('#next')[0]);

        $(controlsObj[0]).removeClass("btn_default").addClass("btn_focus");
        objectFocussed = controlsObj[0];

        $("#lgImg_control ul").children().each(function(i) {

            $(this).on("mouseenter ", function(event) {
                event.stopPropagation();
                if (focusCallBack != null)
                    focusCallBack();
                removeFocus(objectFocussed);
                $(this).removeClass("btn_default").addClass("btn_focus");

                btnIndex = i;
                rowNo = 1;
                objectFocussed = controlsObj[btnIndex];
            });

        });

        $("#lgImg_slideControl ul").children().each(function(i) {

            $(this).on("mouseenter ", function(event) {
                event.stopPropagation();
                if (focusCallBack != null)
                    focusCallBack();
                removeFocus(objectFocussed);
                $(this).removeClass("btn_default").addClass("btn_focus");

                btnIndex = i;
                objectFocussed = slideControlsObj[btnIndex];
            });
        });

        $("#lgImg_zoomControl ul").children().each(function(i) {

            $(this).on("mouseenter ", function(event) {
                event.stopPropagation();
                if (focusCallBack != null)
                    focusCallBack();
                removeFocus(objectFocussed);
                $(this).removeClass("btn_default").addClass("btn_focus");

                btnIndex = i;
                objectFocussed = zoomControlsObj[btnIndex];
            });
        });

        $("#prev").on("mouseenter ", 
function(event) {
            if ($("#prev").is(":visible")) {
                event.stopPropagation();
                if (focusCallBack != null)
                    focusCallBack();
                removeFocus(objectFocussed);

                if (event.type == "mouseenter") {
                    $(this).toggleClass("arrowLefthover");
                    $(this).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex) + "/" + imageList.length + '</div>');
                    $(this).append('<div id="arrowTitle" class="arrowTitle">Previous</div>');
                } else {
                    $(this).removeClass("arrowLefthover");
                    $("#arrowNumber").remove();
                    $("#arrowTitle").remove();
                }
                arrowIndex = 0;
                rowNo = 0;
                objectFocussed = arrowRowObj[arrowIndex];
            }
        });

        $("#next").on("mouseenter ", 
function(event) {
            if ($("#next").is(":visible")) {
                event.stopPropagation();
                if (focusCallBack != null)
                    focusCallBack();
                removeFocus(objectFocussed);

                if (event.type == "mouseenter") {
                    $(this).toggleClass("arrowRighthover");
                    $("#next").css({
                        "position": "absolute",
                        left: $(containerDiv).width() - 120
                    });
                    $(this).append('<div id="arrowNumber" class="arrowNumber">' + (currentIndex + 2) + "/" + imageList.length + '</div>');
                    $(this).append('<div id="arrowTitle" class="arrowTitle">Next</div>');
                } else {
                    $(this).removeClass("arrowRighthover");
                    $("#next").css({
                        "position": "absolute",
                        left: $(containerDiv).width() - 50
                    });
                    $("#arrowNumber").remove();
                    $("#arrowTitle").remove();
                }
                arrowIndex = 1;
                rowNo = 0;
                objectFocussed = arrowRowObj[arrowIndex];
            }
        });

        /*
         * Function moveFocus()
         * @param -num- 1 for down,right    -1 for up,left
         * @param -dir- 'left' for left key.  'right' for Right key
         * @Description - This function implements the on 'left' 'right' 'up' and 'down' function of remote.
         *					Sets and removes focus on the element.									
         * Returns  -void
         */
        moveFocus = function(num, dir) {
            if (slideMode) {
                // navigation for slide controls
                if (dir.length == 0) {
                    if (slideControlsObj[btnIndex + num] != undefined) {
                        btnIndex = btnIndex + num;
                        $(slideControlsObj[btnIndex]).removeClass("btn_default").addClass("btn_focus");
                        removeFocus(objectFocussed);
                        objectFocussed = slideControlsObj[btnIndex];
                    }
                    return;
                } else {
                    return false;
                }
            }
            if (zoomMode) {
                // navigation for zoom controls
                if (dir.length == 0) {
                    if (zoomControlsObj[btnIndex + num] != undefined) {
                        btnIndex = btnIndex + num;
                        $(zoomControlsObj[btnIndex]).removeClass("btn_default").addClass("btn_focus");
                        removeFocus(objectFocussed);
                        objectFocussed = zoomControlsObj[btnIndex];
                    }
                    return;
                } else {
                    return false;
                }
            } else {
                // navigation for normal controls	
                if ((dir == 'up' || dir == 'down')) {
                    if (rowNo + num >= 0 && rowNo + num <= 1) {
                        rowNo += num;
                        switch (rowNo) {
                        case 0:
                            if (imageList.length == 1) {
                                rowNo = 1;
                                return false;
                            } else {
                                if ($(arrowRowObj[0]).is(":visible") && $(arrowRowObj[1]).is(":visible")) {
                                    $(arrowRowObj[arrowIndex]).trigger("mouseenter");
                                } else if ($(arrowRowObj[0]).is(":visible")) {
                                    arrowIndex = 0;
                                    $(arrowRowObj[arrowIndex]).trigger("mouseenter");
                                } else if ($(arrowRowObj[1]).is(":visible")) {
                                    arrowIndex = 1;
                                    $(arrowRowObj[arrowIndex]).trigger("mouseenter");
                                }
                                objectFocussed = arrowRowObj[arrowIndex];
                            }
                            break;
                        case 1:
                            if (controlsObj[btnIndex] != undefined) {
                                $(controlsObj[btnIndex]).removeClass("btn_default").addClass("btn_focus");
                                removeFocus(objectFocussed);
                                objectFocussed = controlsObj[btnIndex];
                            } else {
                                return false;
                            }
                            break;
                        default:
                            break;
                        }
                    } else {
                        return false;
                    }
                } else {
                    switch (rowNo) {
                    case 0:
                        if (imageList.length == 1) {
                            rowNo = 1;
                            return false;
                        } else {
                            if (arrowRowObj[arrowIndex + num] != undefined && ($(arrowRowObj[arrowIndex + num]).is(":visible"))) {
                                arrowIndex = arrowIndex + num;
                                if (arrowIndex == 0) {
                                    $(arrowRowObj[arrowIndex]).trigger("mouseenter");
                                } else if (arrowIndex == 1) {
                                    $(arrowRowObj[arrowIndex]).trigger("mouseenter");
                                }
                                objectFocussed = arrowRowObj[arrowIndex];
                            }
                            break;
                        }
                    case 1:
                        if (controlsObj[btnIndex + num] != undefined) {
                            btnIndex = btnIndex + num;
                            removeFocus(objectFocussed);
                            $(controlsObj[btnIndex]).removeClass("btn_default").addClass("btn_focus");
                            objectFocussed = controlsObj[btnIndex];
                        }
                        break;
                    }
                }
            }
            return true;
        }
        /*
         * Function removeFocus()
         * @param -obj-the current selected HTML object
         * @Description - removes focus from current focussed element.
         * Returns  -void
         */
        removeFocus = function(obj) {
            if ($(obj).hasClass('btn_focus')) {
                $(obj).removeClass('btn_focus').addClass('btn_default');
            }
            if ($(obj).hasClass('arrowLefthover')) {
                $(obj).removeClass('arrowLefthover');
                $("#arrowNumber").remove();
                $("#arrowTitle").remove();

            }
            if ($(obj).hasClass('arrowRighthover')) {
                $(obj).removeClass('arrowRighthover');
                $("#next").css({
                    "position": "absolute",
                    left: $(containerDiv).width() - 50
                });
                $("#arrowNumber").remove();
                $("#arrowTitle").remove();
            }
        }

        /*
		Function buttonClicked()
		@param -chnlNo-the current selected HTML object
		@Description - This function implements the on Enter function of remote.
		Returns  -void
		 */
        buttonClicked = function() {
            var buttonId = $(objectFocussed).attr("id");
            var event = document.createEvent("MouseEvent");
            event.initEvent("click", true, true);
            document.getElementById(buttonId).dispatchEvent(event);

        };

        /*
		Function changeFocusToSlideControls()
		@param -
		@Description - This function implements the key navigation for controls in slide mode.
		Returns  -void
		 */
        changeFocusToSlideControls = function() {
            removeFocus(objectFocussed);
            slideMode = true;
            zoomMode = false;
            btnIndex = 0;
            $(slideControlsObj[0]).removeClass("btn_default").addClass("btn_focus");
            objectFocussed = slideControlsObj[0];
        };

        /*
		Function changeFocusToControls()
		@param -
		@Description - This function implements the key navigation for controls in normal mode.
		Returns  -void
		 */
        changeFocusToControls = function() {
            slideMode = false;
            zoomMode = false;

            btnIndex = 6;
            row = 1;
            if (focusCallBack != null)
                focusCallBack();
            removeFocus(objectFocussed);
            $(controlsObj[6]).removeClass("btn_default").addClass("btn_focus");
            objectFocussed = controlsObj[6];

            if (showZoomControl) {
                btnIndex = 7;
                //setting focus to slideshow start button after stopping slide show
                row = 1;
                removeFocus(objectFocussed);
                $(controlsObj[7]).removeClass("btn_default").addClass("btn_focus");
                objectFocussed = controlsObj[7];
                showZoomControl = false;
            }
        };

        /*
		Function changeFocusToZoomControls()
		@param -
		@Description - This function implements the key navigation for controls in zoom mode.
		Returns  -void
		 */

        changeFocusToZoomControls = function() {
            removeFocus(objectFocussed);
            slideMode = false;
            zoomMode = true;
            btnIndex = 0;
            $(zoomControlsObj[0]).removeClass("btn_default").addClass("btn_focus");
            objectFocussed = zoomControlsObj[0];
        };

    };
    //Constructor invoke
    this._construct()
    }